## openmpi 1.10.2

=== examples/Makefile ===
#
# Copyright (c) 2004-2005 The Trustees of Indiana University and Indiana
#                         University Research and Technology
#                         Corporation.  All rights reserved.
# Copyright (c) 2004-2005 The University of Tennessee and The University
#                         of Tennessee Research Foundation.  All rights
#                         reserved.
# Copyright (c) 2004-2005 High Performance Computing Center Stuttgart, 
#                         University of Stuttgart.  All rights reserved.
# Copyright (c) 2004-2005 The Regents of the University of California.
#                         All rights reserved.
# Copyright (c) 2006-2007 Sun Microsystems, Inc.  All rights reserved.
# Copyright (c) 2011-2014 Cisco Systems, Inc.  All rights reserved.
# Copyright (c) 2012      Los Alamos National Security, Inc.  All rights reserved.
# Copyright (c) 2013      Mellanox Technologies, Inc.  All rights reserved.
# $COPYRIGHT$
# 
# Additional copyrights may follow
# 
# $HEADER$
#

# Use the Open MPI-provided wrapper compilers.  Note that gmake
# requires the CXX macro, while other versions of make (such as Sun's
# make) require the CCC macro.

CC = mpicc
CXX = mpic++
CCC = mpic++
FC = mpifort
JAVAC = mpijavac
SHMEMCC = shmemcc
SHMEMFC = shmemfort

# Using -g is not necessary, but it is helpful for example programs,
# especially if users want to examine them with debuggers.  Note that
# gmake requires the CXXFLAGS macro, while other versions of make
# (such as Sun's make) require the CCFLAGS macro.

CFLAGS = -g
CXXFLAGS = -g
CCFLAGS = -g
FCFLAGS = -g

# Example programs to build

EXAMPLES = \
	 hello_c \
	 hello_cxx \
	 hello_mpifh \
	 hello_usempi \
	 hello_usempif08 \
	 hello_oshmem \
	 hello_oshmemfh \
	 Hello.class \
         ring_c \
	 ring_cxx \
	 ring_mpifh \
	 ring_usempi \
	 ring_usempif08 \
	 ring_oshmem \
	 ring_oshmemfh \
	 Ring.class \
	 connectivity_c \
	 oshmem_shmalloc \
	 oshmem_circular_shift \
	 oshmem_max_reduction \
	 oshmem_strided_puts \
	 oshmem_symmetric_data


# Default target.  Always build the C MPI examples.  Only build the
# others if we have the appropriate Open MPI / OpenSHMEM language
# bindings.

all: hello_c ring_c connectivity_c
	@ if which ompi_info >/dev/null 2>&1 ; then \
	    $(MAKE) mpi; \
	fi
	@ if which oshmem_info >/dev/null 2>&1 ; then \
	    $(MAKE) oshmem; \
	fi

# MPI examples

mpi:
	@ if ompi_info --parsable | grep bindings:cxx:yes >/dev/null; then \
	    $(MAKE) hello_cxx ring_cxx; \
	fi
	@ if ompi_info --parsable | grep bindings:mpif.h:yes >/dev/null; then \
	    $(MAKE) hello_mpifh ring_mpifh; \
	fi
	@ if ompi_info --parsable | grep bindings:use_mpi:yes >/dev/null; then \
	    $(MAKE) hello_usempi ring_usempi; \
	fi
	@ if ompi_info --parsable | grep bindings:use_mpi_f08:yes >/dev/null; then \
	    $(MAKE) hello_usempif08 ring_usempif08; \
	fi
	@ if ompi_info --parsable | grep bindings:java:yes >/dev/null; then \
	    $(MAKE) Hello.class Ring.class; \
	fi

# OpenSHMEM examples

oshmem:
	@ if oshmem_info --parsable | grep oshmem:bindings:c:yes >/dev/null; then \
	    $(MAKE) hello_oshmem; \
	    $(MAKE) ring_oshmem; \
	    $(MAKE) oshmem_shmalloc; \
	    $(MAKE) oshmem_circular_shift; \
	    $(MAKE) oshmem_max_reduction; \
	    $(MAKE) oshmem_strided_puts; \
	    $(MAKE) oshmem_symmetric_data; \
	fi
	@ if oshmem_info --parsable | grep oshmem:bindings:fort:yes >/dev/null; then \
	    $(MAKE) hello_oshmemfh; \
	    $(MAKE) ring_oshmemfh; \
	fi

# The usual "clean" target

clean:
	rm -f $(EXAMPLES) *~ *.o

# Don't rely on default rules for the Fortran and Java examples

hello_mpifh: hello_mpifh.f
	$(FC) $(FCFLAGS) $? -o $@
ring_mpifh: ring_mpifh.f
	$(FC) $(FCFLAGS) $? -o $@

hello_usempi: hello_usempi.f90
	$(FC) $(FCFLAGS) $? -o $@
ring_usempi: ring_usempi.f90
	$(FC) $(FCFLAGS) $? -o $@

hello_usempif08: hello_usempif08.f90
	$(FC) $(FCFLAGS) $? -o $@
ring_usempif08: ring_usempif08.f90
	$(FC) $(FCFLAGS) $? -o $@

Hello.class: Hello.java
	$(JAVAC) Hello.java
Ring.class: Ring.java
	$(JAVAC) Ring.java

hello_oshmem: hello_oshmem_c.c
	$(SHMEMCC) $(CFLAGS) $? -o $@
hello_oshmemfh: hello_oshmemfh.f90
	$(SHMEMFC) $(FCFLAGS) $? -o $@

ring_oshmem: ring_oshmem_c.c
	$(SHMEMCC) $(CFLAGS) $? -o $@
ring_oshmemfh: ring_oshmemfh.f90
	$(SHMEMFC) $(FCFLAGS) $? -o $@

oshmem_shmalloc: oshmem_shmalloc.c
	$(SHMEMCC) $(CCFLAGS) $? -o $@

oshmem_circular_shift: oshmem_circular_shift.c
	$(SHMEMCC) $(CFLAGS) $? -o $@

oshmem_max_reduction: oshmem_max_reduction.c
	$(SHMEMCC) $(CFLAGS) $? -o $@

oshmem_strided_puts: oshmem_strided_puts.c
	$(SHMEMCC) $(CFLAGS) $? -o $@

oshmem_symmetric_data: oshmem_symmetric_data.c
	$(SHMEMCC) $(CFLAGS) $? -o $@

=== ompi/mpi/CMakeLists.txt ===
# Copyright (c) 2007-2008 High Performance Computing Center Stuttgart, 
#                         University of Stuttgart.  All rights reserved.
# $COPYRIGHT$
# 
# Additional copyrights may follow
# 
# $HEADER$
#

IF(OMPI_WANT_CXX_BINDINGS)
  ADD_SUBDIRECTORY(cxx)
ELSE(OMPI_WANT_CXX_BINDINGS)
  MESSAGE(STATUS "Skipping MPI C++ interface")
ENDIF(OMPI_WANT_CXX_BINDINGS)

IF(OMPI_WANT_FORTRAN_BINDINGS)
  ADD_SUBDIRECTORY(fortran)
ELSE(OMPI_WANT_FORTRAN_BINDINGS)
  MESSAGE(STATUS "Skipping MPI FORTRAN interface")
ENDIF(OMPI_WANT_FORTRAN_BINDINGS)

=== orte/test/mpi/Makefile ===
PROGS = mpi_no_op mpi_barrier hello hello_nodename abort multi_abort simple_spawn concurrent_spawn spawn_multiple mpi_spin delayed_abort loop_spawn loop_child bad_exit pubsub hello_barrier segv accept connect hello_output hello_show_help crisscross read_write ziatest slave_spawn slave cell_spawn reduce-hang ziaprobe ziatest bcast_loop parallel_w8 parallel_w64 parallel_r8 parallel_r64 sio sendrecv_blaster early_abort debugger singleton_client_server intercomm_create spawn_tree init-exit77 mpi_info errhandler_fatal

all: $(PROGS)

# These guys need additional -I flags

hello_output: hello_output.c
	$(CC) $(CFLAGS) $(CFLAGS_INTERNAL) $^ -o $@

hello_show_help: hello_show_help.c
	$(CC) $(CFLAGS) $(CFLAGS_INTERNAL) $^ -o $@

CC = mpicc
CFLAGS = -g --openmpi:linkall
CFLAGS_INTERNAL = -I../../.. -I../../../orte/include -I../../../opal/include
CXX = mpic++ --openmpi:linkall
CXXFLAGS = -g
FC = mpifort -openmpi:linkall
FCFLAGS = -g

clean:
	rm -f $(PROGS) *~

=== debian/changelog ===
openmpi (1.10.2-8ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Debug build for powerpc (-O0 instead of -Og).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Feb 2016 17:23:16 +0100

openmpi (1.10.2-8) unstable; urgency=medium

  * Don't ship opal.pc link that conflicts with libopal-dev. Closes: #814515
  * openmpi-doc breaks/replaces openmpi-checkpoint (<< 1.10.2).
    Closes: #814518.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 17 Feb 2016 11:45:09 +0000

openmpi (1.10.2-7ubuntu2) xenial; urgency=medium

  * Debug build for powerpc (-O0 instead of -Og).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Feb 2016 11:46:13 +0100

openmpi (1.10.2-7ubuntu1) xenial; urgency=medium

  * Debug build for powerpc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 11 Feb 2016 22:50:40 +0100

openmpi (1.10.2-7) unstable; urgency=medium

  * x32 support from Adam Borowski. Closes: #814332.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 10 Feb 2016 13:40:56 +0000

openmpi (1.10.2-6) unstable; urgency=medium

  * libopenmpi-dev recommends openmpi-doc. Closes: #813929.
  * Fix formatting errors in man pages.  Silences lintian :-)
  * Define PATH_MAX in ompi_config.h and other fixes for Hurd.
  * Change packages to Arch: any so s390x can build. Closes: #813734.
  * Test suite enabled, so Closes: #719896.
  * Close old bugs as we now support hppa, s390: Closes: #376833, #389306.
  * Build-Conflict on libmpich-dev.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 06 Feb 2016 02:09:58 +0000

openmpi (1.10.2-5) unstable; urgency=medium

  * Do not use --with-verbs on s390x.
  * Enable test suite. Do initial run as experimental to see what breaks :-(

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Feb 2016 11:48:41 +0000

openmpi (1.10.2-4) unstable; urgency=medium

  * Change to Arch: any, as s390x, builds. Closes: #813694.
  * Standards-Version: 3.9.7

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Feb 2016 12:59:21 +0000

openmpi (1.10.2-3) unstable; urgency=medium

  * Add missing links to .pc files in /usr/lib/pkgconfig
  * Disable --with-verbs on kFreeBSD, Hurd.
  * Update openmpi-docs man pages
  * Add links for mpifort. Closes: #813060, #813057.
  * Fix alternatives in postinst. Closes: #734096
  * Delete torque deps in rules; Closes: #769578
  * Close old bug - mpicc-wrapper data no longer contains /usr/lib.
    Closes: #812991.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Feb 2016 18:41:01 +0000

openmpi (1.10.2-2) unstable; urgency=medium

  * libopenmpi1.10 conflicts with libopenmpi1.6. Closes: #813042.
  * Fixes for hppa, hurd patches.
  * checkpoint/restart disabled - lack of upstream maintenance support
    since 1.7+.
  * Drop references to tools no longer shipped in 1.10.2
  * oshmem only supported on Linux, so only try to install on Linux, not
    Hurd or KFreeBSD

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 29 Jan 2016 04:29:18 +0000

openmpi (1.10.2-1) experimental; urgency=medium

  * New upstream release. 
    Closes: #753001, #796982, #796985, #659134,  #657625,  #584702,
    Closes: #579505.
    LP: #1365152, #1390198 
  * Patch refresh:
    - ompi_autogen_sh.patch. Disabled as unnecessary
    - fix-bashims.diff: upstream code removed
    - fix-testsuite-compile : fixed upstream
    - mips-support-upstream-1.7.3.diff: fixed upstream
    - mips-support-fix.diff : ditto
    - ppc64el-support.patch : ditto
  * Change package names 1.6 -> 1.10
  * Close Ophaning bug. Set myself as Maintainer, team as Uploaders.
      Closes: #810079.
  * Include HPPA support from Helge Deller. Closes: #776730.
  * Replace __DATE__ with $(DEBIAN_VERSION) in debug output to make
    build bit-reproducible.
  * libopenmp1.6 recommends openmpi-common; needed for programs to run.
     LP: #398095.
  * Ack. that torque support is dropped. Closes: #767411. Presume that
    openmpi will be informed if a new Torque is introduced to stretch,++.
  * Set --with-ldtl=/usr/ not external; not detected otherwise ?
  * Drop -dbg package as automatic -dbsym packages now generated.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Jan 2016 11:23:11 +0000

openmpi (1.6.5-11) unstable; urgency=medium

  * Build against gcc,gfortran5 for transition. 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 10 Aug 2015 07:55:56 +0100

openmpi (1.6.5-10) unstable; urgency=medium

  * Acknowledge taking maintainership. Closes: #766859.
  * Ack. patch from Willi Mann that fixes FTBFS. Closes: #782653.
  * Move to debhelper compatabililty level 9.
  * Use 'xz' compression
  * Depend on libibverbs >= 1.1.7 for libibverbs ABI change (From Ubuntu)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 22 Jun 2015 18:56:29 +0100

openmpi (1.6.5-9.2) unstable; urgency=medium

  * Non-maintainer upload.
  * libopenmpi1.6: Fix two incorrect soname links.  (Closes: #736675)
  * openmpi-common: Set Multi-Arch: foreign.  (Closes: #769378)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 25 Nov 2014 12:42:38 +0100

openmpi (1.6.5-9.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable torque support (see #767411).

 -- Julien Cristau <jcristau@debian.org>  Fri, 14 Nov 2014 17:57:11 +0100

openmpi (1.6.5-9) unstable; urgency=medium

  * Add myself as uploader.
  * Standards-Version: 3.9.6; no changes required.
  * Rebuild against lastest gfortran. Closes: #647908, #675115.
  * Patch for mpi.pc support. Closes: #752785.
  * Patch from Michael Cree to fix bad atomic ops on Alpha that
    causes mpi4py to segfault. Closes: #754524.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Oct 2014 11:07:44 +0000

=== debian/control ===
Source: openmpi
Section: net
Priority: extra
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Uploaders: Debian Open MPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>,
 Manuel Prinz <manuel@debian.org>, Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 9),
 libibverbs-dev (>= 1.1.7) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 gfortran, gcc (>= 4:5.2.1), chrpath, libhwloc-dev,
 libcr-dev [amd64 armel armhf i386 powerpc], libtool, libltdl-dev,
 libnuma-dev [amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc ppc64el], autoconf (>= 2.59),
 automake
Build-Conflicts: libopenmpi1.6, libopenmpi1.10, libmpich-dev
Standards-Version: 3.9.7
Homepage: http://www.open-mpi.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-openmpi/openmpi/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-openmpi/openmpi/trunk/

Package: openmpi-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openmpi-common (= ${source:Version})
Conflicts: openmpi-bin
Suggests: gfortran, openmpi-checkpoint [amd64 armel armhf i386 powerpc]
Description: high performance message passing library -- binaries
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-2 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 Features:
  * Full MPI-2 standards conformance
  * Thread safety and concurrency
  * Dynamic process spawning
  * High performance on all platforms
  * Reliable and fast job management
  * Network and process fault tolerance
  * Support network heterogeneity
  * Single library supports all networks
  * Run-time instrumentation
  * Many job schedulers supported
  * Internationalized error messages
  * Component-based design, documented APIs
 .
 This package contains the Open MPI utility programs.

Package: libopenmpi-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmpi1.10 (= ${binary:Version}), openmpi-common (= ${source:Version}), 
 libibverbs-dev (>= 1.1.7) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], libhwloc-dev
Conflicts: openmpi-dev, libopenmpi-dev, openmpi-bin (<= 1.2.4-0)
Suggests: opennmpi-doc
Description: high performance message passing library -- header files
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-2 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains the header files and compiler wrappers which are needed
 to compile and link programs against libopenmpi.

Package: libopenmpi1.10
Section: libs
Architecture: any
Recommends: openmpi-bin
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libopenmpi1.6
Description: high performance message passing library -- shared library
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-2 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains the Open MPI shared libraries.

Package: openmpi-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: openmpi-common
Description: high performance message passing library -- common files
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-2 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains platform independent files for Open MPI.

Package: openmpi-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Conflicts: mpi-doc, lam-mpidoc, lam4-dev, openmpi-mpidoc, openmpi-doc
Replaces: openmpi-checkpoint (<< 1.10.2)
Breaks: openmpi-checkpoint (<< 1.10.2)
Description: high performance message passing library -- man pages
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-2 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains man pages describing the Message Passing Interface
 standard.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH),powerpc)
  export DEB_CFLAGS_MAINT_STRIP = -O2
  export DEB_CFLAGS_MAINT_APPEND = -O0
  export DEB_FCFLAGS_MAINT_STRIP = -O2
  export DEB_FCFLAGS_MAINT_APPEND = -O0
  export DEB_CXXFLAGS_MAINT_STRIP = -O2
  export DEB_CXXFLAGS_MAINT_APPEND = -O0
endif

#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEBIAN_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\-.*\)/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

ifeq (sparc,$(DEB_HOST_GNU_CPU))
	CFLAGS += -mcpu=v9
endif

# Memory affinity support
NUMA_ARCH := "amd64 i386 ia64 mips mipsel powerpc"
ifneq (,$(findstring $(DEB_HOST_ARCH),$(NUMA_ARCH)))
        NUMA = --with-libnuma=/usr --with-libnuma-libdir=/usr/lib
endif

# No ibverbs support available on kFreeBSD, Hurd
NO_VERBS_ARCH:= "hurd-i386 kfreebsd-amd64 kfreebsd-i386 s390x"
ifeq (,$(findstring $(DEB_HOST_ARCH),$(NO_VERBS_ARCH)))
        VERBS = --with-verbs
endif

# Flags for the static build: see bug #502232
#STATIC_CONFIG_PARAMS = --enable-static
STATIC_CONFIG_PARAMS =  

# Enable MPI thread support (user request, see #602132). Progress threads are known
# to not work, so we do not enable them until they are supported.
MPI_THREADS := --with-threads=posix --enable-opal-multi-threads

%:
	dh $@ --parallel #--with autotools_dev

override_dh_auto_configure:
	./autogen.sh
	dh_auto_configure -- \
		$(NUMA) $(VERBS) \
		$(MPI_THREADS) \
		$(STATIC_CONFIG_PARAMS) \
		--disable-silent-rules \
		--with-hwloc=/usr/ \
		--with-libltdl=/usr/ \
		--with-devel-headers \
		--with-slurm \
		--with-sge \
		--without-tm \
		--enable-heterogeneous \
		--disable-vt \
		--sysconfdir=/etc/openmpi 		\
		--libdir=\$${prefix}/lib/openmpi/lib	\
		--includedir=\$${prefix}/lib/openmpi/include 

override_dh_install:
# Strip rpath info from all executables and libraries.
	find debian/tmp/ -type f -perm -+x -a ! -name '*.la' -a ! -name '*.mod' -exec chrpath -d '{}' \;
# Rename the compiler and startup wrappers.
	for f in mpic++ mpicc mpiCC mpicxx mpiexec mpif77 mpif90 mpirun mpifort ; do \
		if test -f debian/tmp/usr/bin/$${f}; then \
			mv debian/tmp/usr/bin/$${f} debian/tmp/usr/bin/$${f}.openmpi ; \
		fi; \
	done
# Rename the compiler wrapper man pages.
	for f in mpic++ mpicc mpicxx mpiexec mpif77 mpif90 mpirun mpifort ; do \
		if test -f debian/tmp/usr/share/man/man1/$${f}.1; then \
			mv debian/tmp/usr/share/man/man1/$${f}.1 debian/tmp/usr/share/man/man1/$${f}.openmpi.1 ; \
		fi; \
		if test -f debian/tmp/usr/share/man/man1/$${f}.3; then \
			mv debian/tmp/usr/share/man/man3/$${f}.3 debian/tmp/usr/share/man/man1/$${f}.openmpi.3 ; \
		fi; \
	done
	cd debian/tmp/usr/share/man/man3; \
	for f in *.3; do \
		mv $$f $$(echo $$f|sed -e "s|\.3|.openmpi.3|g"); \
	done; \

# Rename orte-bootproxy.sh to orte-bootproxy
	if test -f debian/tmp/usr/bin/orte-bootproxy.sh; then \
		mv debian/tmp/usr/bin/orte-bootproxy.sh debian/tmp/usr/bin/orte-bootproxy; \
	fi
# Remove dangling symlink(s)
	rm -f debian/tmp/usr/share/man/man1/mpiCC.1
	rm -f debian/tmp/usr/share/man/man1/orteCC.1
# Remove COPYRIGHT file of ptmalloc2. It's reproduced in debian/copyright.
	rm -f -r debian/tmp/usr/share/openmpi/doc/
# Continue as usual
	dh_install
# oshmem, shmem only built on Linux so do by hand or it may fail ...
	if test -f debian/tmp/usr/bin/oshrun ; then \
		cp -a debian/tmp/usr/bin/oshrun  debian/openmpi-bin//usr/bin/ ; \
		cp -a debian/tmp/usr/bin/oshmem_info  debian/openmpi-bin//usr/bin/ ; \
		cp -a debian/tmp/usr/bin/oshcc	 debian/libopenmpi-dev/usr/bin   ; \
		cp -a debian/tmp/usr/bin/oshfort   debian/libopenmpi-dev/usr/bin   ; \
		cp -a debian/tmp/usr/lib/openmpi/lib/liboshmem.so.8.1.0 usr/lib/libopenmpi1.10/usr/lib/openmpi/lib ; \
		cp -a debian/tmp/usr/share/man/man1/oshcc.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/share/man/man1/oshfort.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/share/man/man1/oshrun.1 debian/openmpi-bin/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/share/man/man1/oshmem_info.1 debian/openmpi-bin/usr/share/man/man1 ; \
	fi
	if test -f debian/tmp/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.0 ; then \
		cp -a debian/tmp/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.0 \
			debian/libopenmpi1.10/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.0 ; \
	fi
	if test -f debian/tmp/usr/bin/shmemrun ; then \
		cp -a debian/tmp/usr/bin/shmemrun debian/openmpi-bin/usr/bin/shmemrun ;\
		cp -a debian/tmp/usr/share/man/man1/shmemrun.1 debian/openmpi-bin/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/bin/shmemcc debian/libopenmpi-dev/usr/bin/shmemcc ; \
		cp -a debian/tmp/usr/bin/shmemfort debian/libopenmpi-dev/usr/bin/shmemfort ; \
		cp -a debian/tmp/usr/share/man/man1/shmemcc.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/share/man/man1/shmemfort.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
	fi

override_dh_fixperms:
	chmod 0644 debian/libopenmpi*/usr/lib/openmpi/lib/*.mod
	dh_fixperms

override_dh_installdocs:
	dh_installdocs --all AUTHORS NEWS README

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/tmp/usr/lib/openmpi/lib -- --ignore-missing-info

## openmpi 1.10.3

=== debian/changelog ===
openmpi (1.10.3-3ubuntu2) yakkety; urgency=medium

  [ Graham Inngs ]
  * Rebuild on top of new gcc-6 (fixing bagel build)
  * Revert the Debug build for powerpc
  * This becomes a no-change rebuild

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 05 Aug 2016 11:32:47 +0200

openmpi (1.10.3-3ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Debug build for powerpc (-O0 instead of -Og).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 11 Jul 2016 11:19:23 +0200

openmpi (1.10.3-3) unstable; urgency=medium

  * Fix libmca_common_verbs 7.0.0 -> 7.0.1
  * lenny Breaks: add version to libopenmpi1.4

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 21 Jun 2016 13:00:37 +0100

openmpi (1.10.3-2) unstable; urgency=medium

  Fix missing shlib version change:
  * _tkr moved from 6.1.1 -> 6.2.0

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 16 Jun 2016 12:46:06 +0100

openmpi (1.10.3-1) unstable; urgency=medium

  * New upstream release
   - patch opal_thread_add64.patch merged upstream
   - mpi_win.patch merged upstream
  * Shlib version changes:
   - libmpi 12.0.2 -> 12.0.3
   - libmpi_mpifh 12.0.0 -> 12.0.1
   - libmpi_usempif08 11.1.0 -> 11.1.1
   - libmpi_usempi_ignore_tkr 6.1.0 -> 6.2.0
   - libopen-pal 13.0.2 -> 13.0.3
   - libopen-rte.so 12.0.2 -> 12.0.3
   - liboshmem.so 8.1.0 -> 8.1.1

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 16 Jun 2016 07:12:57 +0100

openmpi (1.10.2-15ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Debug build for powerpc (-O0 instead of -Og).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 Jun 2016 14:20:12 +0200

openmpi (1.10.2-15) unstable; urgency=medium

  * Regression: liboshmem.so.8.1.0 not shipped. Closes: #825575
  * Build against libfabric-dev where possible.
  * Fix: bad regex check on list meant not building against verbs
    on some archs.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 02 Jun 2016 06:44:30 +0100

openmpi (1.10.2-14) unstable; urgency=medium

  * Standards-Version: 3.9.8. No changes required
  * Reproducible builds: Sort glob'bed filelists.
  * Add Breaks/Replaces for libopenmpi1 (lenny upgrade). Closes: #822913.
  * Undo mips chrpath workaround. Closes: #818909
  * Ack. fixed bug. Closes: #818935.
  * Close obsolete bug; cannot occur with openmpi1.10. Closes: 801988.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 May 2016 13:31:19 +0100

openmpi (1.10.2-13) unstable; urgency=medium

  * Fix chrpath on mips64el, mipsel too. Closes: #818909

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 09 Apr 2016 12:14:48 +0100

openmpi (1.10.2-12) unstable; urgency=medium

  * Workaround for chrpath problem on mips. Closes: #818909

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 07 Apr 2016 14:11:30 +0100

openmpi (1.10.2-11) unstable; urgency=medium

  * Typo in install file. Thanks to Patrice DUROUX. Closes: #817020.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 14 Mar 2016 08:03:38 +0000

openmpi (1.10.2-10) experimental; urgency=medium

  * test fix for big-endian systems problem on mpi4py

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 11 Mar 2016 14:02:42 +0000

openmpi (1.10.2-9) unstable; urgency=medium

  * Drop Suggests: for openmpi-checkpoint, which no longer exists.
    Closes: #816648.
  * libopenmpi1.10: Depend on libhwloc-plugins. Closes: #790540.
  * opal_thread_add64.patch: Fix for OPAL_THREAD_ADD64 not
    defined on 32-bit systems. Closes: #816303.
  * Fix broken symlinks in -dev package. Closes: #817020.
  * Fix arch- and bin-only builds (debian/rule). Closes: #816985.
  * Drop unreproducible ia64 bug report. Closes: #720419.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 09 Mar 2016 11:00:41 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libnuma-dev [amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc ppc64el], autoconf (>= 2.59),
  automake
 Build-Conflicts: libopenmpi1.6, libopenmpi1.10, libmpich-dev
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://www.open-mpi.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-openmpi/openmpi/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/pkg-openmpi/openmpi/trunk/
@@ -20,7 +20,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, openmpi-common (= ${source:Version})
 Conflicts: openmpi-bin
-Suggests: gfortran, openmpi-checkpoint [amd64 armel armhf i386 powerpc]
+Suggests: gfortran
 Description: high performance message passing library -- binaries
  Open MPI is a project combining technologies and resources from several other
  projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
@@ -65,8 +65,10 @@
 Section: libs
 Architecture: any
 Recommends: openmpi-bin
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, libhwloc-plugins
 Conflicts: libopenmpi1.6
+Breaks: libopenmpi1.4 (>= 1.4.5-1)
+Replaces: libopenmpi1.4
 Description: high performance message passing library -- shared library
  Open MPI is a project combining technologies and resources from several other
  projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best

=== debian/rules ===
--- 
+++ 
@@ -2,16 +2,7 @@
 
 export DH_VERBOSE=1
 
-ifeq ($(DEB_HOST_ARCH),powerpc)
-  export DEB_CFLAGS_MAINT_STRIP = -O2
-  export DEB_CFLAGS_MAINT_APPEND = -O0
-  export DEB_FCFLAGS_MAINT_STRIP = -O2
-  export DEB_FCFLAGS_MAINT_APPEND = -O0
-  export DEB_CXXFLAGS_MAINT_STRIP = -O2
-  export DEB_CXXFLAGS_MAINT_APPEND = -O0
-endif
 
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -29,8 +20,13 @@
 
 # No ibverbs support available on kFreeBSD, Hurd
 NO_VERBS_ARCH:= "hurd-i386 kfreebsd-amd64 kfreebsd-i386 s390x"
-ifeq (,$(findstring $(DEB_HOST_ARCH),$(NO_VERBS_ARCH)))
+ifneq (,$(findstring $(DEB_HOST_ARCH),$(NO_VERBS_ARCH)))
         VERBS = --with-verbs
+endif
+
+FABRIC_ARCH:="amd64 i386"
+ifeq (,$(findstring $(DEB_HOST_ARCH),$(VERBS_ARCH)))
+        FABRIC = --with-libfabric
 endif
 
 # Flags for the static build: see bug #502232
@@ -44,10 +40,15 @@
 %:
 	dh $@ --parallel #--with autotools_dev
 
+override_dh_auto_clean:
+	dh_clean
+	find . -name .dir-stamp -delete
+	find . -type l -delete
+
 override_dh_auto_configure:
 	./autogen.sh
 	dh_auto_configure -- \
-		$(NUMA) $(VERBS) \
+		$(NUMA) $(VERBS) $(FABRIC) \
 		$(MPI_THREADS) \
 		$(STATIC_CONFIG_PARAMS) \
 		--disable-silent-rules \
@@ -64,7 +65,7 @@
 		--includedir=\$${prefix}/lib/openmpi/include 
 
 override_dh_install:
-# Strip rpath info from all executables and libraries.
+	# Strip rpath info from all executables and libraries.
 	find debian/tmp/ -type f -perm -+x -a ! -name '*.la' -a ! -name '*.mod' -exec chrpath -d '{}' \;
 # Rename the compiler and startup wrappers.
 	for f in mpic++ mpicc mpiCC mpicxx mpiexec mpif77 mpif90 mpirun mpifort ; do \
@@ -99,19 +100,21 @@
 	dh_install
 # oshmem, shmem only built on Linux so do by hand or it may fail ...
 	if test -f debian/tmp/usr/bin/oshrun ; then \
+		mkdir -p debian/libopenmpi1.10/usr/lib/openmpi/lib ; \
 		cp -a debian/tmp/usr/bin/oshrun  debian/openmpi-bin//usr/bin/ ; \
 		cp -a debian/tmp/usr/bin/oshmem_info  debian/openmpi-bin//usr/bin/ ; \
 		cp -a debian/tmp/usr/bin/oshcc	 debian/libopenmpi-dev/usr/bin   ; \
 		cp -a debian/tmp/usr/bin/oshfort   debian/libopenmpi-dev/usr/bin   ; \
-		cp -a debian/tmp/usr/lib/openmpi/lib/liboshmem.so.8.1.0 usr/lib/libopenmpi1.10/usr/lib/openmpi/lib ; \
+		cp -a debian/tmp/usr/lib/openmpi/lib/liboshmem.so.8.1.0 debian/libopenmpi1.10/usr/lib/openmpi/lib ; \
 		cp -a debian/tmp/usr/share/man/man1/oshcc.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
 		cp -a debian/tmp/usr/share/man/man1/oshfort.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
 		cp -a debian/tmp/usr/share/man/man1/oshrun.1 debian/openmpi-bin/usr/share/man/man1 ; \
 		cp -a debian/tmp/usr/share/man/man1/oshmem_info.1 debian/openmpi-bin/usr/share/man/man1 ; \
 	fi
-	if test -f debian/tmp/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.0 ; then \
-		cp -a debian/tmp/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.0 \
-			debian/libopenmpi1.10/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.0 ; \
+	if test -f debian/tmp/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.1 ; then \
+		mkdir -p debian/libopenmpi1.10/usr/lib/openmpi/lib ; \
+		cp -a debian/tmp/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.1 \
+			debian/libopenmpi1.10/usr/lib/openmpi/lib/libmca_common_verbs.so.7.0.1 ; \
 	fi
 	if test -f debian/tmp/usr/bin/shmemrun ; then \
 		cp -a debian/tmp/usr/bin/shmemrun debian/openmpi-bin/usr/bin/shmemrun ;\
@@ -122,7 +125,9 @@
 		cp -a debian/tmp/usr/share/man/man1/shmemfort.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
 	fi
 
-override_dh_fixperms:
+override_dh_install-arch:
+
+override_dh_fixperms-arch:
 	chmod 0644 debian/libopenmpi*/usr/lib/openmpi/lib/*.mod
 	dh_fixperms
